import { Component, Inject } from '@angular/core';
import { Http } from '@angular/http';
import { IgGridComponent, IgValidatorComponent } from 'igniteui-angular2';
import { HomeService } from './home.service';
import { IHome } from './home';

declare var $: any;
@Component({
    selector: 'home',
    templateUrl: './home.component.html',
    providers: [HomeService]
})
export class HomeComponent {
    private gridOptions: IgGrid;
    private id: string;
    private errorMessage: string;
    private gridHome: IHome[] = [];
    private users: any[] = [];
    private validatorOpts: IgValidator;
    private validationRes: boolean = true;

    ngOnInit(): void {



        this._homeService.getHome()
            .subscribe(data => {
                this.gridHome = data;

            },
            error => this.errorMessage = <any>error);


        this._homeService.getUsers()
            .subscribe(data => {
                this.users = data;

            },
            error => this.errorMessage = <any>error);



    }

    constructor(private _homeService: HomeService) {
        var me = this;

        this.validatorOpts = {
            fields: [],
            custom: {
                onblur: true,
                method: function (value, fieldOps) {
                    $("#TestTypeGrid_updating_dialog_container_footer_buttonok").igButton("option", "disabled", !me.validationRes);
                    return me.validationRes;
                },
                errorMessage: "user doesn't exist"
            }
        };

        //this.data = this.ErrorTypes;
        this.id = 'TestTypeGrid';
        this.gridOptions = {

            autoCommit: true,
            dataSource: this.gridHome,
            width: "100%",
            height: "710px",
            autoGenerateColumns: false,
           
            rendered: (e, ui) => {
                //ui.owner.dataSource.settings.restSettings.contentType = undefined;
                //$.ajaxSetup({
                //    url: "",
                //    xhrFields: {
                //        withCredentials: true
                //    }
                //})
            },
            columns: [
                { key: "userId", headerText: "userId", width: "20%", dataType: "number" },
                { key: "id", headerText: "id", width: "20%", dataType: "number" },
                { key: "title", headerText: "title", width: "20%", dataType: "string" },
                { key: "body", headerText: "body", width: "60%", dataType: "string" },
            ],  
            restSettings: {
                create: {
                    url: "https://jsonplaceholder.typicode.com/posts/",
                    batch: false
                },
                update: {
                    url: "https://jsonplaceholder.typicode.com/posts/",
                    batch: false
                },
                delete: {
                    url: "https://jsonplaceholder.typicode.com/posts/",
                    batch: false
                },
            },
            primaryKey: "id",
            features: [
                {
                    name: "Updating",
                    editMode: "dialog",
                    rowEditDialogOptions: {
                        showEditorsForHiddenColumns: true,
                        showReadonlyEditors: false,
                        dialogTemplateSelector: "#dialogtemp"
                    },
                    rowEditDialogAfterOpen: function (e, ui) {

                        $("#customValidator").igValidator("addField", { selector: $("input[data-editor-for-userId]") });

                    },
                    editRowStarted: function (evt, ui) {
                        //var editor = $("#TestTypeGrid").igGridUpdating("editorForKey", "userId");
                            //if (editor) {
                            //    editor.igCombo("option", "dataSource", me.users);
                            //    editor.igCombo("dataBind");
                            //}
                    },
                    editRowEnded: function (evt, ui) {

                        if (ui.update || ui.rowAdding) {
                            $("#TestTypeGrid").igGrid("saveChanges", function (data) {
                                $("#message").text("Changes were saved successfully").fadeIn(3000).fadeOut(5000);
                            },
                                function (jqXHR, textStatus, errorThrown) {
                                    $("#message").text("An error occurred while saving the changes. Error details: " + textStatus).fadeIn(3000).fadeOut(5000);
                                    //me.search();
                                });
                        }
                    },
                    columnSettings: [
                        { columnKey: "id", readOnly: true, editorType: 'text' },
                        {
                            columnKey: "userId",
                            editorType: 'text',
                            required: true,
                            editorOptions: {
                                validatorOptions: {
                                    custom: function () {
                                        debugger;
                                        return me.validationRes;

                                    }
                                },
                                valueChanged: function (e, ui) {
                                    me._homeService.validateUser(ui.newValue)
                                        .subscribe(data => {
                                            if (data) {
                                                me.validationRes = true;
                                            } else {
                                                me.validationRes = false;
                                            }
                                            $("#customValidator").igValidator("validate");
                                        }, error => {
                                            me.validationRes = false;
                                            $("#customValidator").igValidator("validate");
                                        });
                                
                                },
                            }
                            //editorOptions: {
                            //    mode: "dropdown",
                            //    dataSource: this.users,
                            //    textKey: "name",
                            //    valueKey: "id",
                               
                            //}
                        }
                    ]
                },
                {
                    name: "Paging"
                },
                {
                    name: "Filtering"
                },
                {
                    name: "Sorting"
                }
            ]
        }
        
    }

    clicked() {
        //trigger your remote call and in the result callback force validation by calling the validate method.
        debugger;
        this.validationRes = false;
        $("#customValidator").igValidator("validate");
    }

    public saveGrid() {

        var transactions = $("#TestTypeGrid").igGrid("pendingTransactions");
        for (let transaction of transactions) {
            if (transaction.type == "newrow") {

            } else if (transaction.type == "deleterow") {

            } else {

            }
        }

        //$("#TestTypeGrid").igGrid("saveChanges", function (data) {

        //    $("#message").text("Changes were saved successfully").fadeIn(15000).fadeOut(15000);
        //    //temp1.tempPrimaryKey = -1;
        //},
        //    function (jqXHR, settings, textStatus, errorThrown) {

        //    });

    }

}
